require( "iuplua" )

launch_and_explode = {}
launch_and_explode.expl_timer = Timer()
launch_and_explode.loop_timer = Timer()
launch_and_explode.running = false
launch_and_explode.new_buyback_dlg = {}
launch_and_explode.buyback_timer = Timer()
launch_and_explode.yes_btn = {}
launch_and_explode.orig_buyback_dlg = MakeBuyBackQuestionDlg
MakeBuyBackQuestionDlg = function (...)
   launch_and_explode.new_buyback_dlg = launch_and_explode.orig_buyback_dlg()
   launch_and_explode.yes_btn = launch_and_explode.new_buyback_dlg[1][1][1][1][2]
   return launch_and_explode.new_buyback_dlg
end

function launch_and_explode.l_a_e()
   StationLaunchButton:action()
   print("\127ffffffPlease, wait 10 secs for /explode .. (relaunching after "..launch_and_explode.minutes_between_launches.." minutes)")
   launch_and_explode.expl_timer:SetTimeout(10000, function() gkinterface.GKProcessCommand('explode') end)
end

function launch_and_explode:OnEvent(event, data)
   if event == "ENTERED_STATION" then
      if launch_and_explode.running == true then
	 launch_and_explode.buyback_timer:SetTimeout(5000, function() launch_and_explode.yes_btn:action(); end)
	 print("\127ff6600Launcing again after "..launch_and_explode.minutes_between_launches.." minutes. Stop: /lexp off")
	 launch_and_explode.loop_timer:SetTimeout(launch_and_explode.minutes_between_launches*60*1000, function() launch_and_explode.l_a_e() end)
      end
   end
end

function launch_and_explode.usage()
   print("\127ffffffUsage: /lexp on <minutes to relaunch> | off")
end

function launch_and_explode.parse_commands(_, args)
   if args == nil then 
      launch_and_explode.usage()
      return
   end
   if args[1] == "on" and args[2] ~= nil and tonumber(args[2]) ~= nil and tonumber(args[2]) > 0 then 
      launch_and_explode.running = true
      launch_and_explode.minutes_between_launches = tonumber(args[2])
      launch_and_explode.l_a_e()
   elseif args[1] == "off" then 
      launch_and_explode.running = false
      launch_and_explode.expl_timer:Kill()
      launch_and_explode.loop_timer:Kill()
      print("\127ffffffStopped launch_and_explode")
   else
      launch_and_explode.usage()
   end
end

RegisterUserCommand('lexp', launch_and_explode.parse_commands)
RegisterEvent(launch_and_explode, "ENTERED_STATION")
